#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define C 8

void leggi_matrice(char *m, int n);
int trova(char *m, int n, char *s);

int main(){
    int n;
    char w[C + 1];
    
    scanf("%d\n", &n);
    
    char *g = malloc(n * C * sizeof(char));

    if (!g) return 0;

    leggi_matrice(g, n);

    while (scanf("%s", w) == 1) {
        printf("%s:%d\n", w, trova(g,n,w));
    }

    printf("%s\n", g);

    free(g);

    return 0;
}

void leggi_matrice(char *m, int n) {
    for (int i=0; i<n; i++) {
        scanf("%8c\n", &m[C*i]);
    }
    
    printf("%s\n", m);
}

int lunghezza_str(char* s) {
    int res = 0;
    while (s[res] != '\0') {
        res++;
    }
    return res;
}

int trova(char *m, int n, char *s) {
    int len = lunghezza_str(s);
    int trovata;

    for (int i=0; i<n; i++) {
        for (int j=0; j<C; j++) {
            // trova orizzontale
            if (len + j <= C) {
                trovata = 1;
                for (int k = 0; k<len; k++) {
                    if (m[C*i + j + k] != s[k]) {
                        trovata = 0;
                        break;
                    }
                }
                if (trovata) return 1;
            }
            // trova orizzontale al contrario
            if (j - len + 1 >= 0) {
                trovata = 1;
                for (int k = len-1; k>=0; k--) {
                    if (m[C*i + j - k] != s[k]) {
                        trovata = 0;
                        break;
                    }
                }
                if (trovata) return 2;
            }

            // trova verticale
            if (len + i <= n) {
                trovata = 1;
                for (int k = len-1; k>=0; k--) {
                    if (m[C*(i+k) + j] != s[k]) {
                        trovata = 0;
                        break;
                    }
                }
                if (trovata) return 3;
            }
            // trova verticale al contrario
            if (i - len + 1 >= 0) {
                trovata = 1;
                for (int k = len-1; k>=0; k--) {
                    if (m[C*(i-k) + j] != s[k]) {
                        trovata = 0;
                        break;
                    }
                }
                if (trovata) return 4;
            }
        }
    }

    return 0;
}