#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXSTRLEN 31

typedef struct {
  int n;
  char **oggetto;
  int *quantita;
  float *costo;
} spesa_t;

spesa_t leggi_lista(char *nomefile);

float totale(spesa_t *l);

char *mediano(spesa_t *l);

int main() {
  char nome[256];
  spesa_t s;
  scanf("%s", nome);
  s = leggi_lista(nome);
  printf("%.2f\n", totale(&s));
  printf("%s\n", mediano(&s));
  if (s.n > 0) {
    for (int i = 0; i < s.n; ++i) {
      free(s.oggetto[i]);
    }  
    free(s.oggetto);
    free(s.quantita);
    free(s.costo);
  }
  return 0;
}

#define PROF_SOLUTION

spesa_t leggi_lista(char *nomefile) {
  FILE *f = fopen(nomefile, "r");
  spesa_t spesa = {0, NULL, NULL, NULL};

  int quantita; 
  float costo;
  char oggetto[MAXSTRLEN];

  if (f == NULL) {
    printf("Error opening the file!\n");
    exit(0);
  }

  spesa.n = 0;

  while (fscanf(f, "%s %d %f", oggetto, &quantita, &costo) == 3) {
    spesa.n++;
  }

  spesa.costo = malloc(spesa.n * sizeof(float));
  spesa.oggetto = malloc(spesa.n * sizeof(char*));
  spesa.quantita = malloc(spesa.n * sizeof(int));

  rewind(f);
  for (int i=0; i<spesa.n; i++) {
    fscanf(f, "%s %d %f", oggetto, &spesa.quantita[i], &spesa.costo[i]);
    
    spesa.oggetto[i] = malloc(MAXSTRLEN * sizeof(char));
    strncpy(spesa.oggetto[i], oggetto, MAXSTRLEN);
  }

  fclose(f);

  return spesa;
}

float totale(spesa_t *l) {
  float tot = 0.0;
  for (int i=0; i<l->n; i++) {
    tot = tot + l->costo[i] * l->quantita[i];
  }
  return tot;
}

char *mediano(spesa_t *l) {
  int num_le;
  int num_ge;
  int num_eq;

  for (int i=0; i<l->n; i++) {
    num_le = 0;
    num_ge = 0;
    num_eq = 0;
    for (int j=0; j<l->n; j++) {
      if (i == j) continue;
      if (l->costo[j] > l->costo[i]) {
        printf("%s <= %s\n", l->oggetto[i], l->oggetto[j]);
        num_ge++;
      }
      else if (l->costo[j] < l->costo[i]) {
        printf("%s >= %s\n", l->oggetto[i], l->oggetto[j]);
        num_le++;
      }
      else num_eq++;
    }
    printf("%s: %d %d\n", l->oggetto[i], num_le, num_ge+num_eq);
    if (num_le == num_ge + num_eq) {
      return l->oggetto[i];
    }
  }

  return "No Mediana";
}
